(setq editfns
      '(editf editp editv edits edmsg findfirst smash edread rplaceall
	editpr tailp))

(setq editvars nil)

(defmacro editf (fn &rest l)
	`(edits (symbol-function ',fn) ',l))

(defmacro editp (fn &rest l)
	`(edits (symbol-plist ',fn) ',l))

(defmacro editv (fn &rest l)
	`(edits (symbol-value ',fn) ',l))

(defun edits (s &optional edcom)
  (prog (cl ctls plevel temp x a b l)
	(and (atom s)
	     (print "Not editable")
	     (return nil))
	(setq *edcom*
	      (and edcom
		   (append edcom '(ok))))
  start
	(setq plevel (printlevel 2))
      b
	(setq cl s)
	(setq ctls (list cl))
   next
	(setq l (edread))
	(cond ((atom l)
	        (go atoml)))
	(setq x (car l))
	(setq l (cdr l))
	(cond ((numberp x)
		(go numcarx))
	      ((get x 'deeditl)
		(setq *edcom*
		      (append (apply (get x 'deeditl)
				     (list l))
			      *edcom*))
		(go next))
	      (t (case x
			((r rall)
			  (cond ((setq x
				       (rplaceall (car l)
						  (cadr l)
						  cl)))
				(t (print "nothing replaced"))))
			(n  (nconc cl l))
			(us (cond ((setq temp
					 (copy (get (car l)
						    'editvalue)))
				   (setq *edcom*
					 (append (subst temp
							(car l)
							(cdr l))
						 *edcom*)))
				   (t (go illg))))
			(mark (putprop (car l)
				       ctls
				       'editchain))
			(to (cond ((and (symbolp (car l))
						(setq temp
						      (get (car l)
							    'editchain)))
					   (setq cl (car temp))
					   (setq ctls temp))
					  (t (go illg))))
				(rc (setq *edcom*
					 (cons 'up
					       (cons (cons 1 l)
						     *edcom*))))
				(mbd (setq *edcom*
					   (cons (cons ':
						       (subst cl '* l))
						 (cons 1 *edcom*))))
				(go cont))))
	      (go next)
	cont
	      (cond ((or (not (numberp (car l)))
			 (< (car l) 1))
		     (go illg)))
	      (or (setq temp
			(nthcdr (1- (car l))
				cl))
		  (go empty))
	      (case x 
		       (lo (smash temp
				  (caar temp)
				  (cdar temp)))
		       (li (smash temp
				  (cons (car temp)
					(cdr temp))
				  nil))
		       (ro (nconc (car temp) (cdr temp))
			   (rplacd temp nil))
		       (ri (or (numberp (cadr l))
			       (go illg))
			   (setq a
				 (nthcdr (1- (cadr l))
					 (car temp)))
			   (and (null l)
				(go empty))
			   (rplacd temp
				   (nconc (cdr a)
					  (cdr temp)))
			   (rplacd a nil))
		       (bo (smash temp
				  (caar temp)
				  (nconc (cdar temp)
					 (cdr temp))))
		       (bi (setq b
				 (cdr (setq a
					    (cond ((null (numberp (cadr l)))
						   (cdr temp))
						  (t (nthcdr (1- (cadr l))
							     cl))))))
			   (rplacd a nil)
			   (smash temp
				  (cons (car temp)
					(cdr temp))
				  b))
		       (go illg))
	      (go next)
	numcarx
	      (cond ((zerop x)
		     (go illg))
		    ((< x 0)
		     (cond ((= x -1)
			    (setq l
				  (nconc l
					 (cons (car cl)
					       (cdr cl))))
			    (smash cl
				   (car l)
				   (cdr l)))
			   ((not (consp (setq a
					  (nthcdr (- 2 x)
						  cl))))
			    (go empty))
			   (t (rplacd a
				      (nconc l (cdr a))))))
		    ((= x 1)
		     (cond (l (smash cl
				     (car l)
				     (nconc (cdr l)
					    (cdr cl))))
			   ((not (consp (cdr cl)))
			    (go empty))
			   (t (smash cl
				     (cadr cl)
				     (cddr cl)))))
		    ((not (consp (setq a
				   (nthcdr (- x 2)
					   cl))))
		     (go empty))
		    (t (rplacd a
			       (cond ((cdr a)
				      (nconc l (cddr a)))
				     (t l)))))
	      (go next)
	atoml
	      (setq x l)
	      (cond ((numberp x)
		     (cond ((zerop x)
			    (or (cdr ctls)
				(go top))
			    (setq ctls (cdr ctls))
			    (setq cl (car ctls)))
			   (t (and (< x 0)
				   (setq x
					 (plus (length cl)
					       1
					       x)))
			      (setq x
				    (nthcdr (1- x) cl))
			      (or (listp x)
				  (go empty))
			      (setq cl (car x))
			      (setq ctls
				    (cons cl ctls)))))
		    (t (case x
			       (p  (editpr cl cl ctls))
			       (pp (editpr cl cl ctls t))
			       (ok (printlevel plevel)
				   (return s))
			       (up (cond ((tailp cl (cadr ctls)))
					 ((null (cdr ctls))
					  (go top))
					 (t (setq ctls (cdr ctls))
					    (setq cl (member cl
							     (car ctls)
							     :test
							     eq))
					    (or (eq cl (car ctls))
						(setq ctls
						      (cons cl ctls))))))
			       (e  (setq x (eval (edread)))
				   (or *edcom* (print x)))
			       (f  (setq temp
					 (findfirst (edread) cl ctls))
				   (cond ((null temp) (edmsg "not found"))
					 (t (setq ctls temp)
					    (setq cl (car temp))))
				   (cond ((atom cl)
					  (setq *edcom* (cons 'up *edcom*)))))
			       (!  (go b))
			       (nx (cond ((tailp cl (cadr ctls))
					  (setq cl (cdr cl))
					  (rplaca ctls cl))
					 (t (setq ctls (cdr ctls))
					    (setq cl
						  (cadr (member cl
								(car ctls)
								:test
								eq)))
					    (setq ctls (cons cl ctls)))))
			       (?  (editpr cl cl ctls nil 100))
			       (?? (editpr cl cl ctls t 100))
			       (s (setq a (edread))
				  (cond ((symbolp a)
					 (putprop a cl 'editvalue))
					(t (go illg))))
			       (cond ((get x 'deedita)
				      (setq *edcom*
					    (append (eval (get x 'deedita))
						    *edcom*)))
				     (t (go illg))))))
	      (go next)
	illg
	      (edmsg "Illegal command")
	top
	      (edmsg "on top level")
	empty
	      (edmsg "list empty")))

(defun edmsg (msg)
	(print msg)
;;;;;;;;;;;;;;;;	(readpos 150)
	(setq *edcom* nil)
	(go next))

(defun findfirst (a s trc)
	(prog (res)
	      (cond ((not (consp s))
		     (return nil))
		    ((equal a (car s))
		     (return (cons (car s) trc)))
		    ((setq res (member a (cdr s)))
		     (return (cons (car res) trc)))
		    ((setq res (findfirst a
					  (car s)
					  (cons (car s) trc)))
		     (return res)))
	loop  (setq s (cdr s))
	      (cond ((not (consp s))
		     (return nil))
		    ((setq res (findfirst a
					  (car s)
					  (cons (car s) trc)))
		     (return res)))
	      (go loop)))

(defun smash (x a b)
	     (rplaca x a)
	     (rplacd x b))

(defun edread ()
	      (cond ((null *edcom*)
		     (princ "edit:")
		     (read))
		    (t (prog1 (car *edcom*)
			      (setq *edcom* (cdr *edcom*))))))

(defun rplaceall (a new s)
		 (prog (res)
		  loop (cond ((not (consp s))
			      (return res))
			     ((equal (car s) a)
			      (setq res t)
			      (rplaca s new))
			     (t (setq res
				      (or (rplaceall a new (car s))
					  res))))
		       (setq s (cdr s))
		       (go loop)))

(defun editpr (x cl ctls &optional pp depth)
	      (setq depth (printlevel depth))
	      (cond ((tailp cl (cadr ctls))
		     (princ "--- ")
		     (mapc x '(lambda (y)
				      (cond (pp (printdef y)
						(spaces 4))
					    (t (prin1 y)
					       (spaces 1)))))
		     (princ ")")
		     (terpri))
		    (t (cond (pp (printdef x))
			     (t (print x)))))
	      (printlevel depth))

(defun tailp (x l)
	     (cond ((null (cdr l)) nil)
		   ((eq x (cdr l)) x)
		   (t (tailp x (cdr l)))))
