(setq prettyfns '(printlevel pp prettyprint printdef ppslave))

(setq prettyvars nil)

(defun printlevel (&optional x)
		  (prog1 (get 'printlevel 'printlevel)
			 (if (numberp x)
			     (putprop 'printlevel x 'printlevel))))

(defmacro pp (&rest x)
	 `(prettyprint ',x))

(defun prettyprint (x)
	(if (symbolp x)
	    (setq x (symbol-value x)))
	(if (not (consp x))
	    (error "bad argument to prettyprint: " x))
	(prog (l fun)
	      (setq l x)
	  lop (setq fun (car l))
	      (setq l (cdr l))
	      (if (symbolp fun)
		  (progn (print fun)
			 (printdef (symbol-function fun))))
	      (if (null l) (return x))
	      (terpri)
	      (go lop)))

(defun printdef (x)
	(ppslave x 0 (printlevel))
	(terpri)
	x)

(defun ppslave (x indent &optional depth)
    (prog (newindent y)
	(cond ((atom x)
		(prin1 x)
		(return (+ indent (flatsize x))))
	      ((or (not (numberp depth))
		   (plusp depth))
		(princ "(")
		(setq indent (1+ indent))
		(setq newindent (ppslave (car x)
					 indent
					 (and (numberp depth)
					      (1- depth))))
		(dolist (y (cdr x))
			(terpri)
			(dotimes (i indent) (princ " "))
			(setq newindent
			      (ppslave y
				       indent
				       (and (numberp depth)
					    (1- depth)))))
		(princ ")")
		(return (1+ newindent)))
	      (t
		(princ "&")
		(return (1+ indent))))))
